*---------------------------------------------------------------------------
* PrntAdj.prg  by Roger Seiler  roger@leadersoft.com     April 5, 2006
*              Determine necessary printer position adjustments and
*              save appropriate re-positioning codes to ini file for
*              reference by printing programs.              
*
*              Must use this in conjuction with TRept23.prg and must
*              print test file PrinTest.txt via Button with ID 12.
*---------------------------------------------------------------------------

 // Note: all references to "s360" or "Qcswin" have to do with Seiler's
 //       apps and have to be changed to appropriate names of your own apps.
 //       cCall passes in a one-letter code to tell which app called the proc.

 // See file PrntAdj.txt for Help text for end user.

STATIC cCaller := "" // This must be at top of PRG as a file-wide static.
*------------------------
 // Adjust length of printed page...
PROCEDURE PrnLen(nPrnLinAdj,oParent,cCall)

LOCAL oDlg,oRadio,nSel,oGet,nGet := 00,cPrnLinCor := "",oGet2,;
      nPrnLinCor := 0, cPrnLinPol := "-",oSay20,cSay20 := "",nMultPoint := 0,;
      aFonts := {},oGet3,nBoxCor := .0
LOCAL cIniFile := "", cIniFileW := "",cCurDir := "",oRept23
LOCAL cIniPart := "MyPart", cMyApp := ""

DEFAULT cCall TO "Q"
cCaller := cCall

  // Change this for your apps....
  IF cCall == "Q"
     cMyApp := "Qcswin"
  ELSE
     cMyApp := "S360"
  ENDIF

  cCurdir := CurDir()
  IF AT("\",cCurdir) > 0
     cCurdir := SUBSTR(cCurdir, AT("\",cCurdir)+1,10)
     cCurdir := Alltrim(cCurdir)
  ENDIF

   // INI file on server...
  cIniFile := CurDrive()+":\"+CurDir()+"\"+cMyApp+".ini"   
   // INI file on workstation handling specific printer for workstation...
  cIniFileW := GetWinDir()+"\"+cMyApp+".ini"

  IF cCall == "S"
     cMyPart := "S360"
    ELSE
     cMyPart := "QCSWIN"
  ENDIF


  IF !FILE(cIniFileW)
     cIniFileW := cIniFile
  ENDIF

  cPrnLinCor := GetPvProfString( cIniPart , "PrnLinCor"  , "0" , cIniFileW )
  cPrnLinPol := GetPvProfString( cIniPart , "PrnLinPol"  , "-" , cIniFileW )
  nMultPoint := VAL(GetPvProfString( cIniPart , "MultPoint"  , "1" , cIniFileW ) )
  nBoxCor    := VAL(GetPvProfString( cIniPart , "BoxCor"    , ".0" , cIniFileW ) )

aFonts := {;
          {"TIMES NEW ROMAN", 0,-11, ""},;
          {"TIMES NEW ROMAN", 0,-11, "BOLD"},;
          {"TIMES NEW ROMAN", 0,-11, "ITALIC"},;
          {"", 0,0, ""},;
          {"", 0,0, ""},;
          {"", 0,0, ""};
          }

nPrnLinCor := VAL(cPrnLinCor)

cSay20 := ALLTRIM(cPrnLinPol) + ALLTRIM(cPrnLinCor)

DEFINE DIALOG oDlg RESOURCE "PRINTLEN" OF oParent

  // Current print length correction...
REDEFINE SAY oSay20 PROMPT cSay20 ID 20 OF oDlg

  // Remove (nSel=1) or Add (nSel=2) lines to printed page...
REDEFINE RADIO oRadio VAR nSel ID 13,14 OF oDlg

  // Number of lines to remove or add.
REDEFINE GET oGet VAR nGet PICTURE "99" ID 101 OF oDlg
       oGet:bGotFocus = {||oGet:SetPos(0,0)} 

REDEFINE BUTTON ID 12 OF oDlg ;  // Print out alignments test...
  ACTION ( oRept23 := TRept23():New("PRINTEST.TXT",,aFonts,,.f.), ; // Print it
           oRept23:Activate(), ;
           oRept23 := nil ;
          )

  // Printhead point multiplier.
REDEFINE GET oGet2 VAR nMultPoint PICTURE "9.99" ID 102 OF oDlg
       oGet2:bGotFocus = {||oGet2:SetPos(0,0)} 

  // Graphics alignment correction.
REDEFINE GET oGet3 VAR nBoxCor PICTURE "9.99" ID 103 OF oDlg
       oGet3:bGotFocus = {||oGet3:SetPos(0,0)} 

REDEFINE BUTTON ID 11 OF oDlg ;
  ACTION PrnAdj(@nPrnLinAdj,cCall,nSel,nGet,@cPrnLinPol,;
                @nPrnLinCor,@cPrnLinCor,nMultPoint,nBoxCor),;
                cSay20 := ALLTRIM(cPrnLinPol) + ALLTRIM(STR(INT(nPrnLinAdj/24))),;
                oSay20:Refresh(),;
         MsgInfo("Adjustments made as requested.")

REDEFINE BUTTON ID 2 OF oDlg ;
  ACTION oDlg:End()

REDEFINE BUTTON ID 4 OF oDlg ;
  ACTION HelpTopic( 1122 )

ACTIVATE DIALOG oDlg CENTERED ;
      RESIZE16

  // cPrnLinPol tells polarity of adjustment -- plus or minus.
  // nPrnLinCor tells number of vertical units to add or subtract.
  // R&R uses 24 vertical units per line.

RETURN
*--------------
// Deal with an adjustment to number of lines to print on a page, due to
// limitations of the printer being used...
STATIC PROCEDURE PrnAdj(nPrnLinAdj,cCall,nSel,nGet,cPrnLinPol,;
                        nPrnLinCor,cPrnLinCor,nMultPoint,nBoxCor)

LOCAL cIniFile := "", cIniFileW := "",cCurDir := ""
LOCAL cIniPart := "MyPart", cMyApp := ""

DEFAULT cCall TO "Q"
cCaller := cCall

cCurdir := CurDir()
IF AT("\",cCurdir) > 0
   cCurdir := SUBSTR(cCurdir, AT("\",cCurdir)+1,10)
   cCurdir := Alltrim(cCurdir)
ENDIF


  // Change this for your apps....
IF cCaller == "Q"
   cMyApp := "Qcswin"
   cMyPart := "Qcswin"
ELSE
   cMyApp := "S360"
   cMyPart := "S360"
ENDIF

cIniFile := CurDrive()+":\"+CurDir()+"\"+cMyApp+"ini"
cIniFileW := GetWinDir()+"\s360.ini"


IF !FILE(cIniFileW)
   cIniFileW := cIniFile
ENDIF


IF nSel = 1 .AND. cPrnLinPol == "-"
     nPrnLinCor := nPrnLinCor + nGet
    ELSEIF nSel = 1 .AND. cPrnLinPol == "+"
     nPrnLinCor := nPrnLinCor - nGet
    ELSEIF nSel = 2 .AND. cPrnLinPol == "-"
     nPrnLinCor := nPrnLinCor - nGet
    ELSEIF nSel = 2 .AND. cPrnLinPol == "+"
     nPrnLinCor := nPrnLinCor + nGet
    ELSE
     nPrnLinCor := nPrnLinCor + nGet
ENDIF

IF nPrnLinCor < 0 .AND. cPrnLinPol == "-"
     cPrnLinPol := "+"
     nPrnLinCor := -1 * nPrnLinCor  // Force to a positive number for ini.
   ELSEIF nPrnLinCor < 0 .AND. cPrnLinPol == "+"
     cPrnLinPol := "-"
     nPrnLinCor := -1 * nPrnLinCor  // Force to a positive number for ini.
    ELSE
ENDIF

// See TRept23.prg for examples of how to use these adjustment codes....
WritePProString( cMyPart, "PrnLinCor"  , alltrim(str((nPrnLinCor),2)), cIniFileW )
WritePProString( cMyPart, "PrnLinPol"  , cPrnLinPol, cIniFileW )
WritePProString( cMyPart, "MultPoint"  , alltrim(str(nMultPoint,5,2)), cIniFileW )
WritePProString( cMyPart, "BoxCor"  , alltrim(str(nBoxCor,5,2)), cIniFileW )

nPrnLinAdj := nPrnLinCor * 24   // Passed back by reference.
IF cPrnLinPol == "+"
   nPrnLinAdj := nPrnLinAdj * -1
ENDIF


RETURN
*---------------------
/*  Here is a sample of some code that would be used in a printing program
    to utilize the proper adjustments for number of lines on a page...


   nPrnLinAdj := PrnAdj()

   nPrintLines := nPrintLines - nPrnLinAdj

*/